/*  gngeo a neogeo emulator
 *  Copyright (C) 2001 Peponas Mathieu
 * 
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "../neocd.h"
#include "streams.h"
#include "sound.h"
#include <dc/sound/stream.h>
int sound=1;

#define BUFFER_LEN 16384 //SND_STREAM_BUFFER_MAX //
extern u16 play_buffer[BUFFER_LEN]__attribute__((aligned(32)));


void *audio_callback( int samples_requested, int *samples_returned)
{
	streamupdate(samples_requested);
	*samples_returned = samples_requested;
	return play_buffer;
}
int init_sdl_audio(void)
{
    streams_sh_start();
	YM2610_sh_start();

    snd_stream_init(*audio_callback);
	snd_stream_start(SAMPLE_RATE, 2);
	
    return 1;
}

void sound_toggle(void) {
    if(sound)
        snd_stream_stop();
    else
       snd_stream_start(SAMPLE_RATE,2);
 
	sound^=1;
}
void sound_disable(void) {
	sound =0;
	snd_stream_stop();
}

void sound_enable(void) {
	sound = 1;
	snd_stream_start(SAMPLE_RATE,2);
}

void
play_audio(void) //called every VBL
{
	snd_stream_poll();

}

void sound_shutdown(void) {

   	snd_stream_stop();
	snd_stream_shutdown();

    streams_sh_stop();
    YM2610_sh_stop();
    
}



