

#include "../neocd.h"
#include "streams.h"
#include "sound.h"

int sound=1;

#define BUFFER_LEN 16384
extern u16 play_buffer[BUFFER_LEN]__attribute__((aligned(32)));
extern u16 left_buffer[BUFFER_LEN]__attribute__((aligned(32)));
extern u16 right_buffer[BUFFER_LEN]__attribute__((aligned(32)));
int *stream;

static const uint8 stream_driver[] = {
	#include "aica_fw.h"
};

#define ARM_OFFSET 0xa0800000
static volatile uint32 *start  = (uint32*)(0x10000 + ARM_OFFSET);
static volatile uint32 *init_done = (uint32*)(0x10004 + ARM_OFFSET);
static volatile uint32 *play_start = (uint32*)(0x10008 + ARM_OFFSET);
static volatile uint32 *rate = (uint32*)(0x10010 + ARM_OFFSET);
static volatile uint32 *bits = (uint32*)(0x10014 + ARM_OFFSET);
static volatile uint32 *buf_len = (uint32*)(0x10018 + ARM_OFFSET);
static volatile uint32 *position  = (uint32*)(0x10020 + ARM_OFFSET);
#define BASE_ADDRESS 0x11000

static const uint32 base = 0xa0800000 + 0x11000;

void play_audio(void){
	if(sound){
	streamupdate(16384);
	spu_memload( base, *play_buffer,16384);
	aica_play(0,0,base,0,2048,22050,255,128,1);
	}

}

int init_sdl_audio(void){
	  
	aica_init();
	spu_memset( base, 0,16384);
	
  *init_done = 0; /* need before spu_memload */

  g2_fifo_wait();
  
  spu_disable();
  spu_memload (0, &stream_driver, sizeof(stream_driver));
  spu_enable ();
  
  *rate = SAMPLE_RATE;
  *bits = 16;
  *buf_len = BUFFER_LEN ; 

  g2_fifo_wait ();
  
  for (;;)
  {
    if (*init_done) break;
    timer_spin_sleep (100);
  }
  
  *start = 1;
  g2_fifo_wait ();
  
  for (;;)
  {
    if (*play_start) break;
    timer_spin_sleep (100);
  }

    streams_sh_start();
	YM2610_sh_start();

	return 1;
}

void sound_toggle(void) {

	sound^=1;
}

void sound_shutdown(void) {
    
    streams_sh_stop();
    YM2610_sh_stop();
    
}



